<template>
    <StackLayout>
        <Button class="bg-sky-300 button" :text="`Cambiar Fecha: ${today}`" @tap="selectDate" />
        <Label class="bg-slate-500 p-3 text-white text-center" :text="'Mes: ' + month" textWrap="true" />
        <StackLayout orientation="horizontal">
            <StackLayout width="1%" />
            <StackLayout class="bg-slate-400" v-for="d, k in days" :key="k" width="14%">
                <Label class="border p-2 text-center" :text="d" textWrap="true" />
            </StackLayout>
            <StackLayout width="1%" />
        </StackLayout>
        <StackLayout orientation="horizontal" v-for="row in nroRows" :key="row">
            <StackLayout width="1%" />
            <StackLayout v-for="col in 7" :key="col" width="14%" class="border" :class="{
                'bg-blue-200': getDay(row, col) > start && getDay(row, col) < end,
                'bg-blue-500': getDay(row, col) == start || getDay(row, col) == end
            }">
                <Button v-if="getDay(row, col) > 0 && getDay(row, col) <= endOf" :text="getDay(row, col)"
                    @tap="setDays(getDay(row, col))" class="rounded-xl p-1 bg-indigo-200" height="35" width="80%" />
            </StackLayout>
            <StackLayout width="1%" />
        </StackLayout>
        <GridLayout rows="*" columns="*,*">
          <StackLayout col="0" class="p-5 rounded m-2 text-center bg-zinc-300">
                <Label :text="`Fecha pickUp:`" textWrap="true" />
                <Label :text="`${start} - ${month}`" textWrap="true" />
                <Label :text="`Hora: ${pickUpHour}:00`" textWrap="true" />
            </StackLayout>
            <StackLayout col="1" class="p-5 rounded m-2 text-center bg-zinc-300">
                <Label :text="`Fecha dropOff:`" textWrap="true" />
                <Label :text="`${end} - ${month}`" textWrap="true" />
                <Label :text="`Hora: ${dropOffHour}:00`" textWrap="true" />
            </StackLayout>
        </GridLayout>
        <Slider v-model="pickUp" />
        <Slider v-model="dropOff" />
    </StackLayout>
</template>

<script>
import moment from 'moment'
import DatePopup from './DatePopup'

export default {
    data() {
        return {
            today: null,
            days: ["L", "M", "M", "J", "V", "S", "D",],
            day: 1,
            start: null,
            end: null,
            pickUp: 0,
            dropOff: 0,
        }
    },
    components: { DatePopup },
    created() {
        this.today = moment().format("YYYY-MM-DD")
    },
    computed: {
        month() {
            return moment(this.today).format('MMMM');//this.today.getMonth()
        },
        startOf() {
            const day1 = moment(this.today).startOf('month')
            return parseInt(moment(day1).day());
        },
        endOf() {
            const day2 = moment(this.today).endOf('month')
            return parseInt(moment(day2).format("D"));
        },
        nroRows() {
            const tot = this.endOf + this.startOf - 1
            const mod = tot % 7
            const div = (tot - mod) / 7
            return mod > 0 ? div + 1 : div
        },
        pickUpHour() {
            return Math.round(this.pickUp * 24 / 100)
        },
        dropOffHour() {
            return Math.round(this.dropOff * 24 / 100)
        },
    },
    methods: {
        getDay(row, col) {
            return (((row - 1) * 7) + col) - (this.startOf - 1)
        },
        setDays(n) {
            if (this.start && this.end) {
                //si ambos
                this.start = n
                this.end = null
            } else
                this.start
                    ? n < this.start ? this.start = n : this.end = n
                    : this.start = n
        },
        selectDate() {
            this.$showModal(DatePopup, { props: { today: this.today } })
                .then(newToday => {
                    if (newToday)
                        this.today = moment(newToday).format("YYYY-MM-DD")
                });
        }
    }
}
</script>